<?php
/*
Plugin Name: FeedOnly
Plugin URI: http://coolidea.ru/2008/06/07/feedonly
Description: Plugin hides chosen parts of postings from common visitors and shows them to feed-subscribers only. Place the text you want to show only to your subscribers between &lt;!&ndash;&ndash;hide&ndash;&ndash;&gt; and &lt;!&ndash;&ndash;/hide&ndash;&ndash;&gt;.
Version: 1.0
Author: Oleg Shalomanov
Author URI: http://coolidea.ru
*/

add_filter('the_content', 'cool_hide');

define (start_hide_tag, '<!--hide-->');
define (finish_hide_tag, '<!--/hide-->');
define (start_hide_tag_length, strlen(start_hide_tag));
define (finish_hide_tag_length, strlen(finish_hide_tag));

$blog_feed_url='/wp-rss2.php';

//you can change the values of variables below
$hidden_content_mark = '</p>[For RSS subscribers only. <a href="'.$blog_feed_url.'">Subscribe</a> to get exclusive content in time.]<p>';
$hidden_content_start = '</p>&lt;Exclusively for subscribers&gt;&nbsp;<p>';
$hidden_content_finish = '</p>&nbsp;&lt;/Exclusively for subscribers&gt;<p>';
//

function cool_hide ($content)
{
	global $hidden_content_mark, $hidden_content_start, $hidden_content_finish;

	$processedContent = $content;
	$patternFound = true;

	while ($patternFound == true)
	{
		$startPos = strpos($processedContent, start_hide_tag);

		if ($startPos === false)
		{
			$patternFound = false;
		}
		else
		{
			$endPos = strpos($processedContent, finish_hide_tag, $startPos);

			if ($endPos === false) {
				// end tag is absent
				if (is_feed()) {
					$processedContent = substr($processedContent,0,$startPos) . $hidden_content_start . substr($processedContent, $startPos + start_hide_tag_length) . $hidden_content_finish;					
				} else {
					$processedContent = substr($processedContent,0,$startPos) . $hidden_content_mark;
				}
			} else {
				if (is_feed()) {
					$processedContent = substr($processedContent,0,$startPos) . $hidden_content_start . substr($processedContent, $startPos + start_hide_tag_length, $endPos - ($startPos + start_hide_tag_length)) . $hidden_content_finish . substr($processedContent,$endPos + finish_hide_tag_length);
				} else {
					$processedContent = substr($processedContent,0,$startPos) . $hidden_content_mark . substr($processedContent,$endPos + finish_hide_tag_length);
				}
			}
		}
	}
	return $processedContent;
}
?>